<?php
/**
 * @category   Newsroom
 * @package    Newsroom_Presskit
 * @author     dushyantjoshia@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Newsroom\Presskit\Controller\Index;

use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Store\Model\StoreManagerInterface;
use Newsroom\Presskit\Block\PresskitView;
use Newsroom\Presskit\Model\ImageRepository;
use Newsroom\Presskit\Model\ResourceModel\Image\CollectionFactory;

class Downloadimage extends \Magento\Framework\App\Action\Action {
	protected $_presskitview;
	protected $storeManager;

	public $filesystem;

	public $file;

	private $directory;

	public $driver;
	private $collectionFactory;
	public $fileFactory;
	public function __construct(
		Context $context,
		StoreManagerInterface $storeManager,
		\Magento\Framework\Filesystem $filesystem,
		\Magento\Framework\Filesystem\Io\File $file,
		\Magento\Framework\Filesystem\Driver\File $driver,
		ImageRepository $imageRepository,
		CollectionFactory $collectionFactory,
		\Magento\Framework\App\Response\Http\FileFactory $fileFactory,
		PresskitView $presskitview
	) {
		$this->_presskitview = $presskitview;
		$this->imageRepository = $imageRepository;
		$this->filesystem = $filesystem;
		$this->file = $file;
		$this->driver = $driver;
		$this->fileFactory = $fileFactory;
		$this->collectionFactory = $collectionFactory;
		$this->storeManager = $storeManager;
		parent::__construct($context);
	}

	public function execute() {

		/*if(!$this->_presskitview->getSingleData()){
			    		throw new NotFoundException(__('Parameter is incorrect.'));
		*/

		$image_id = $this->getRequest()->getParam('image_id');
		$image = $this->imageRepository->getById($image_id);
		$filePath = $this->filesystem->getDirectoryRead(DirectoryList::MEDIA)->getAbsolutePath() . $image->getImages();

		$downloadName = basename($image->getImages());
		$content['type'] = 'filename';
		$content['value'] = $filePath;
		$content['rm'] = 0; // If you will set here 1 then, it will remove file from location.
		return $this->fileFactory->create($downloadName, $content, DirectoryList::PUB);
	}

}
